### More aggressive incremental clean of `obj` directory for certain scenarios

In previous versions, Xamarin.Android reserved a costlier, more complete
incremental clean of the intermediate output directory for special scenarios
where a NuGet package changed or where the `$(AndroidPackageNamingPolicy)`
MSBuild property changed.  Xamarin.Android 10.3 expands this behavior to
cover several other MSBuild properties:

  *`$(AndroidAotMode)`
  *`$(AndroidCreatePackagePerAbi)`
  *`$(AndroidDexTool)`
  *`$(AndroidEmbedProfilers)`
  *`$(AndroidEnableProfiledAot)`
  *`$(AndroidExplicitCrunch)`
  *`$(AndroidGenerateJniMarshalMethods)`
  *`$(AndroidIncludeDebugSymbols)`
  *`$(AndroidLinkMode)`
  *`$(AndroidLinkSkip)`
  *`$(AndroidLinkTool)`
  *`$(AndroidNdkDirectory)`
  *`$(AndroidPackageFormat)`
  *`$(AndroidSdkBuildToolsVersion)`
  *`$(AndroidSdkDirectory)`
  *`$(AndroidSequencePointsMode)`
  *`$(AndroidUseLatestPlatformSdk)`
  *`$(AndroidUseSharedRuntime)`
  *`$(AotAssemblies)`
  *`$(BundleAssemblies)`
  *`$(EmbedAssembliesIntoApk)`
  *`$(JavaSdkDirectory)`
  *`$(MonoSymbolArchive)`
  *`$(OS)`
  *`$(TargetFrameworkVersion)`
  *`$(XamarinAndroidVersion)`

This should reduce the number of cases where project authors need to run a full
clean by hand after changing one of these properties, such as after updating to
a new Xamarin.Android version.

Changes to these particular properties already triggered additional build
steps, so this new behavior should not noticeably increase incremental build
times. As in the past, to get the best incremental build times, avoid changing
these properties back and forth too much between builds.
